-- Car handling ui created by Fragnatiq, based on SimpleMenu by Dank Rafft.		

HandlingUtil = {
	description = "",
	--rootPath = "handlingmenu." not needs for now
}

function HandlingUtil:new()

	setmetatable(HandlingUtil, self)
	self.__index = self

	GUIbind = 0x24        -- can change 
	version = "alpha"
	----------------------
	--	  VARIABLES 	--
	----------------------

	local showUI = false

	local buttonWs = 20
	local buttonW1 = 55
	local buttonW2 = 100
	local buttonW3 = 110
	local buttonW4 = 150
	local buttonHs = 15
	local buttonH1 = 20
	local buttonH2 = 30
	
	function HelpMarker(tip)
	ImGui.TextDisabled("(?)")
	 if (ImGui.IsItemHovered()) then
	 ImGui.BeginTooltip()
	 ImGui.TextUnformatted(tip)
	 ImGui.EndTooltip()
	 end
	end

	----------
	-- INIT --
	----------

	registerForEvent("onInit", function()
		print("*Car handling UI loaded, touch [home] for menu.")
	end)
	

	-----------------------
	-- HOTKEYS FUNCTIONS --
	-----------------------

	registerForEvent("onUpdate", function(deltaTime)
		--UIToggle
		if (ImGui.IsKeyPressed(GUIbind, false)) then
			showUI = not showUI
		end
		


	end)


	--------
	-- UI --
	--------

	registerForEvent("onDraw", function()

		if (showUI) then

			ImGui.SetNextWindowPos(0, 450, ImGuiCond.FirstUseEver)
			ImGui.SetNextWindowSize(270, 510, ImGuiCond.Appearing)
	
			local elements = {
				tabsize = {
					x = 270,
					y = {
						item = 250,
						advanced = 470,
						other = 180,
						about = 120
					}
				},
				button = {
					height = 19,
					width = {
						dialogue = 100,
						dialoguehalf = 44,
						tripple = 159,
						double = 242,
						single = 493
					}
				},
				itemwidth = {
					singledialoguebutton = 385,
					singledialogue = 492,
					doubledialoguebutton = 189,
					doubledialogue = 242
				}
			}

			if (ImGui.Begin("Car handling UI [" .. version .. "]")) then
				
				if (ImGui.BeginTabBar("bar")) then
				
					--ITEMS
					if (ImGui.BeginTabItem("ITEMS")) then
					ImGui.AlignTextToFramePadding()       -- TEST@FIX
						ImGui.SetWindowSize(elements.tabsize.x, elements.tabsize.y.item)

						ImGui.Text("[DRIVING HELPERS]")
						ImGui.SameLine()
						HelpMarker("Presets for fast switching between. ON = vanilla parameters, can be used as RESET TO DEFAULTS.")
						if (ImGui.Button("ON", buttonW1, buttonH2)) then
							GameOptions.Set("Vehicle","ForceMoveToMaxAngularSpeed","5")    -- 5
							GameOptions.Set("Vehicle","ForceMoveToMaxLinearSpeed","30")    -- 30
							GameOptions.Set("Vehicle","VelocitySmoothingTime","0.3")       -- 0.3
							GameOptions.Set("Vehicle","physicsCCD","false")
							GameOptions.Set("vehicle","PhysXClampHugeSpeeds","true")
							GameOptions.Set("vehicle","PhysXClampHugeImpacts","true")
							GameOptions.Set("Vehicle","BikeHackTiltCalcValue","50")		   -- 50
							GameOptions.Set("vehicle","PhysXTimeCompensationFactor","0.8")
							GameOptions.Set("Input","FakeAxisRepeatRate","5")
							GameOptions.Set("Streaming/Culling/NonAirVehicle","SaturationVelocity","20")
							GameOptions.Set("Streaming/Culling/NonAirVehicle","ThresholdVelocity","5")
							GameOptions.Set("vehicle","PhysXMinTimeStep","0.011111")
							GameOptions.Set("Vehicle","WeightTransferMode","1")
							GameOptions.Set("Vehicle","AirControlBikePitchHelper","true")
							GameOptions.Set("Vehicle","AirControlCarRollHelper","true")
							GameOptions.Set("Vehicle","EnableAirResistane","true")
							GameOptions.Set("Vehicle","EnableFreeRotationResistantTorque","true")
							GameOptions.Set("Vehicle","EnableLowVelStoppingResistance","true")
							GameOptions.Set("Vehicle","EnableSmoothWheelContacts","true")
							GameOptions.Set("Vehicle","UseDifferential","true")
							GameOptions.Set("Vehicle","vehicleVsVehicleCollisions","true")
							GameOptions.Set("Vehicle","trafficVsTrafficCollisions","false")
							GameOptions.Set("Vehicle","EnableFreeRotationResistantTorque","true")
							GameOptions.Set("Vehicle","EnableLowVelStoppingResistance","true")
							GameOptions.Set("Vehicle","ForceSimplifiedMovement","false")
						end
						if (ImGui.IsItemHovered()) then
         				 ImGui.SetTooltip("RESET TO DEFAULTS")
						end
						ImGui.SameLine()
						
						if (ImGui.Button("BALANCED", buttonW2, buttonH2)) then
							GameOptions.Set("Vehicle","ForceMoveToMaxAngularSpeed","1")    -- 0
							GameOptions.Set("Vehicle","ForceMoveToMaxLinearSpeed","5")     -- 0
							GameOptions.Set("Vehicle","VelocitySmoothingTime","0.15")      -- 0.1
							GameOptions.Set("Vehicle","physicsCCD","false")
							GameOptions.Set("vehicle","PhysXClampHugeSpeeds","false")
							GameOptions.Set("vehicle","PhysXClampHugeImpacts","true")
							GameOptions.Set("Vehicle","BikeHackTiltCalcValue","35")        -- 35
							GameOptions.Set("vehicle","PhysXTimeCompensationFactor","0.3") -- 0.3
							GameOptions.Set("Input","FakeAxisRepeatRate","0")
							GameOptions.Set("Streaming/Culling/NonAirVehicle","SaturationVelocity","40")
							GameOptions.Set("Streaming/Culling/NonAirVehicle","ThresholdVelocity","20")
							GameOptions.Set("vehicle","PhysXMinTimeStep","0.011111")
							GameOptions.Set("Vehicle","WeightTransferMode","1")
						end
						if (ImGui.IsItemHovered()) then
        				 ImGui.SetTooltip("Balance between comfort and realism in my opinion.")
						end
						ImGui.SameLine()
						
						if (ImGui.Button("OFF", buttonW1, buttonH2)) then
							GameOptions.Set("Vehicle","ForceMoveToMaxAngularSpeed","0")    -- 0
							GameOptions.Set("Vehicle","ForceMoveToMaxLinearSpeed","0")     -- 0
							GameOptions.Set("Vehicle","VelocitySmoothingTime","0")      -- 0.1
							GameOptions.Set("Vehicle","physicsCCD","false")
							GameOptions.Set("vehicle","PhysXClampHugeSpeeds","false")
							GameOptions.Set("vehicle","PhysXClampHugeImpacts","true")
							GameOptions.Set("Vehicle","BikeHackTiltCalcValue","-1")        -- 35
							GameOptions.Set("vehicle","PhysXTimeCompensationFactor","0.3") -- 0.3
							GameOptions.Set("Input","FakeAxisRepeatRate","0")
							GameOptions.Set("Streaming/Culling/NonAirVehicle","SaturationVelocity","40")
							GameOptions.Set("Streaming/Culling/NonAirVehicle","ThresholdVelocity","20")
							GameOptions.Set("vehicle","PhysXMinTimeStep","0.000800")
							GameOptions.Set("Vehicle","WeightTransferMode","1")
						end
						if (ImGui.IsItemHovered()) then
        				 ImGui.SetTooltip("Turns off almost all driving helpers.")
						end
						ImGui.Spacing()
						
						if (ImGui.Button("REALISM", buttonW3, buttonH2)) then
							GameOptions.Set("Vehicle","ForceMoveToMaxAngularSpeed","1")    -- 0
							GameOptions.Set("Vehicle","ForceMoveToMaxLinearSpeed","5")     -- 0
							GameOptions.Set("Vehicle","VelocitySmoothingTime","0")      -- 0.1
							GameOptions.Set("Vehicle","physicsCCD","false")
							GameOptions.Set("vehicle","PhysXClampHugeSpeeds","false")
							GameOptions.Set("vehicle","PhysXClampHugeImpacts","true")
							GameOptions.Set("Vehicle","BikeHackTiltCalcValue","-1")        -- 35
							GameOptions.Set("vehicle","PhysXTimeCompensationFactor","0.1") -- 0.3
							GameOptions.Set("Input","FakeAxisRepeatRate","0")
							GameOptions.Set("Streaming/Culling/NonAirVehicle","SaturationVelocity","20")
							GameOptions.Set("Streaming/Culling/NonAirVehicle","ThresholdVelocity","5")
							GameOptions.Set("vehicle","PhysXMinTimeStep","0.011111")
							GameOptions.Set("Vehicle","WeightTransferMode","-1")			
						end
						if (ImGui.IsItemHovered()) then
        				 ImGui.SetTooltip("Helpers off. Weight transfer mode changes. Each vehicle handles differently. Throttle while cornering leads to instant reverse except FWD cars. For DIRT Rally lovers :3")
						end
						ImGui.SameLine()
						
						if (ImGui.Button("DRIFT", buttonW3, buttonH2)) then
							GameOptions.Set("Vehicle","ForceMoveToMaxAngularSpeed","0")    -- 0
							GameOptions.Set("Vehicle","ForceMoveToMaxLinearSpeed","15")     -- 0
							GameOptions.Set("Vehicle","VelocitySmoothingTime","0.3")      -- 0.1
							GameOptions.Set("Vehicle","physicsCCD","true")
							GameOptions.Set("vehicle","PhysXClampHugeSpeeds","false")
							GameOptions.Set("vehicle","PhysXClampHugeImpacts","false")
							GameOptions.Set("Vehicle","BikeHackTiltCalcValue","-1")        -- 35
							GameOptions.Set("vehicle","PhysXTimeCompensationFactor","0.1") -- 0.3
							GameOptions.Set("Input","FakeAxisRepeatRate","0")
							GameOptions.Set("Streaming/Culling/NonAirVehicle","SaturationVelocity","20")
							GameOptions.Set("Streaming/Culling/NonAirVehicle","ThresholdVelocity","5")
							GameOptions.Set("vehicle","PhysXMinTimeStep","0.011111")
							GameOptions.Set("Vehicle","WeightTransferMode","-1")			
						end
						if (ImGui.IsItemHovered()) then
        				 ImGui.SetTooltip("Adaptation to controlled cornering with realistic car behavior.")
						end
						ImGui.Separator()
						ImGui.Spacing() 					
						ImGui.Text("Forced inertions : Angular")
						ImGui.SameLine()
						ImGui.SmallButton(GameOptions.GetFloat("Vehicle","ForceMoveToMaxAngularSpeed") .. "")
        					if (ImGui.IsItemHovered()) then
            				ImGui.SetTooltip("default=5.0")
							end
						ImGui.Text("					Linear")
						ImGui.SameLine()
						ImGui.SmallButton(GameOptions.GetFloat("Vehicle","ForceMoveToMaxLinearSpeed") .. "")
        					if (ImGui.IsItemHovered()) then
        					ImGui.SetTooltip("default=30.0")
							end

						ImGui.Spacing()
							if (ImGui.Button("CUT HIGH SPEEDS", buttonW4, buttonH1)) then
							GameOptions.Toggle("Vehicle","PhysXClampHugeSpeeds")
							end
							 if (ImGui.IsItemHovered()) then
        					 ImGui.SetTooltip("Cuts 'car bump into sky weeee' speeds. True by default.")
							 end
						ImGui.SameLine()
						ImGui.Text("[" .. GameOptions.Get("Vehicle","PhysXClampHugeSpeeds") .. "]")


						ImGui.Spacing()
							if (ImGui.Button("CLAMP HUGE IMPACTS", buttonW4, buttonH1)) then
							GameOptions.Toggle("Vehicle","PhysXClampHugeImpacts")
							end
							 if (ImGui.IsItemHovered()) then
        					 ImGui.SetTooltip("Possible fixes sudden explosions. Hard to test. True by default.")
							 end
						ImGui.SameLine()
						ImGui.Text("[" .. GameOptions.Get("Vehicle","PhysXClampHugeImpacts") .. "]")


					ImGui.EndTabItem()
					end
					

					--MISC
					if (ImGui.BeginTabItem("ADVANCED")) then
						ImGui.SetWindowSize(elements.tabsize.x, elements.tabsize.y.advanced)
						ImGui.Spacing()
						
					-- BIKE TILT
						ImGui.Text("[Bike tilting helper]")
						ImGui.SameLine()
						HelpMarker("Helps to tilt bike while cornering. Lower=more realistic, higher=more help. At -1 works clumsy.")

						bikehack = GameOptions.GetFloat("Vehicle","BikeHackTiltCalcValue")
						bikehackch = ImGui.SliderInt("bike", math.floor(bikehack), -1, 99,"%d")
						ImGui.SameLine()
						if (bikehack) ~= (bikehackch) then
						GameOptions.SetFloat("Vehicle","BikeHackTiltCalcValue", bikehackch)
						end
						ImGui.SameLine()
						if (ImGui.Button("50", buttonWs, buttonHs)) then
						GameOptions.Set("Vehicle","BikeHackTiltCalcValue","50")
						end
						if (ImGui.IsItemHovered()) then
        				ImGui.SetTooltip("RESET to 50")
						end
						
		
						-- LINEAR
						ImGui.Text("[FORCE TO MAX LINEAR SPD]")
						ImGui.SameLine()
						HelpMarker("Amount of forced linear inertia.")
						forceL = GameOptions.GetFloat("Vehicle","ForceMoveToMaxLinearSpeed")
						forceLch = ImGui.SliderInt("line", math.floor(forceL), -1, 99,"%d")
						ImGui.SameLine()
		
						if (forceL) ~= (forceLch) then
						GameOptions.SetFloat("Vehicle","ForceMoveToMaxLinearSpeed", forceLch)
						end
						ImGui.SameLine()
						if (ImGui.Button("30", buttonWs, buttonHs)) then
						GameOptions.Set("Vehicle","ForceMoveToMaxLinearSpeed","30")
						end
						if (ImGui.IsItemHovered()) then
        				ImGui.SetTooltip("RESET to 30")
						end
		
						-- ANGULAR
						ImGui.Text("[FORCE TO MAX ANGULAR SPD]")
						ImGui.SameLine()
						HelpMarker("Amount of forced angular inertia.")
						forceA = GameOptions.GetFloat("Vehicle","ForceMoveToMaxAngularSpeed")
						forceAch = ImGui.SliderInt("angu", math.floor(forceA), -1, 99,"%d")
						ImGui.SameLine()
		
						if (forceA) ~= (forceAch) then
						GameOptions.SetFloat("Vehicle","ForceMoveToMaxAngularSpeed", forceAch)
						end
						ImGui.SameLine()
						if (ImGui.Button("5", buttonWs, buttonHs)) then
						GameOptions.Set("Vehicle","ForceMoveToMaxAngularSpeed","5")
						end
						if (ImGui.IsItemHovered()) then
        				ImGui.SetTooltip("RESET to 5")
						end
		
						-- CUTS
						ImGui.Spacing()
						if (ImGui.Button("SIMPLIFIED MOVEMENT", buttonW4, buttonH1)) then
						GameOptions.Toggle("Vehicle","ForceSimplifiedMovement")
						end
						ImGui.SameLine()
						ImGui.Text("[" .. GameOptions.Get("Vehicle","ForceSimplifiedMovement") .. "]")
						ImGui.SameLine()
						HelpMarker("Applies simplified physics model of driving. While enabled car ignores small collisions. Can fix some driving problems. False by default.")	
						
						ImGui.Spacing()
						if (ImGui.Button("BIKE PITCH CUT", buttonW4, buttonH1)) then
						GameOptions.Toggle("Vehicle","AirControlBikePitchHelper")
						end
						ImGui.SameLine()
						ImGui.Text("[" .. GameOptions.Get("Vehicle","AirControlBikePitchHelper") .. "]")
						ImGui.SameLine()
						HelpMarker("Cut bike's attempts to ride on rear wheel. True by default.")
						
						ImGui.Spacing()
						if (ImGui.Button("CAR ROLL CUT", buttonW4, buttonH1)) then
						GameOptions.Toggle("Vehicle","AirControlCarRollHelper")
						end
						ImGui.SameLine()
						ImGui.Text("[" .. GameOptions.Get("Vehicle","AirControlCarRollHelper") .. "]")
						ImGui.SameLine()
						HelpMarker("Cut car's roll over attempts. True by default.")
						
						ImGui.Spacing()
						if (ImGui.Button("AIR RESISTANCE", buttonW4, buttonH1)) then
						GameOptions.Toggle("Vehicle","EnableAirResistane")
						end
						ImGui.SameLine()
						ImGui.Text("[" .. GameOptions.Get("Vehicle","EnableAirResistane") .. "]")
						ImGui.SameLine()
						HelpMarker("Air resistance switch, NOT DOWNFORCE. Does more realistic acceleration in cost of max speed. True by default.")
	  				
						ImGui.Spacing()
						if (ImGui.Button("STOPPING RESISTANCE", buttonW4, buttonH1)) then
						GameOptions.Toggle("Vehicle","EnableLowVelStoppingResistance")
						end
						ImGui.SameLine()
						ImGui.Text("[" .. GameOptions.Get("Vehicle","EnableLowVelStoppingResistance") .. "]")
						ImGui.SameLine()
						HelpMarker("Doing light deceleration without pressing gas pedal. True by default.")	 
				
						ImGui.Spacing()
						if (ImGui.Button("SMOOTH WHEEL CONTACT", buttonW4, buttonH1)) then
						GameOptions.Toggle("Vehicle","EnableSmoothWheelContacts")
						end
						ImGui.SameLine()
						ImGui.Text("[" .. GameOptions.Get("Vehicle","EnableSmoothWheelContacts") .. "]")
						ImGui.SameLine()
						HelpMarker("Fixes wheels's bounce from small obstacles.  True by default.")			
				
						ImGui.Spacing()
						if (ImGui.Button("physicsCCD", buttonW4, buttonH1)) then
						GameOptions.Toggle("Vehicle","physicsCCD")
						end
						ImGui.SameLine()
						ImGui.Text("[" .. GameOptions.Get("Vehicle","physicsCCD") .. "]")
						ImGui.SameLine()
						HelpMarker("Physics testing mode. While enabled physics calsulated always, even car is stopped. False by default.")		
						
						ImGui.Spacing()
						if (ImGui.Button("USE DIFFERETIAL", buttonW4, buttonH1)) then
						GameOptions.Toggle("Vehicle","UseDifferential")
						end
						ImGui.SameLine()
						ImGui.Text("[" .. GameOptions.Get("Vehicle","UseDifferential") .. "]")
						ImGui.SameLine()
						HelpMarker("It is. Help with cornering with throttle. While disabled makes drifting easier. True by default.")		
				
						ImGui.Spacing()
						if (ImGui.Button("TRAFFIC COLLISIONS", buttonW4, buttonH1)) then
						GameOptions.Toggle("Vehicle","trafficVsTrafficCollisions")
						end
						ImGui.SameLine()
						ImGui.Text("[" .. GameOptions.Get("Vehicle","trafficVsTrafficCollisions") .. "]")
						ImGui.SameLine()
						HelpMarker("Enables or disables collisions between AI cars. True by default.")		
				
						ImGui.Spacing()
						if (ImGui.Button("VEHICLE COLLISIONS", buttonW4, buttonH1)) then
						GameOptions.Toggle("Vehicle","vehicleVsVehicleCollisions")
						end
						ImGui.SameLine()
						ImGui.Text("[" .. GameOptions.Get("Vehicle","vehicleVsVehicleCollisions") .. "]")
						ImGui.SameLine()
						HelpMarker("Enables or disables collisions between cars. True by default.")	

					ImGui.EndTabItem()
					end
					
					if (ImGui.BeginTabItem("OTHER")) then
						ImGui.SetWindowSize(elements.tabsize.x, elements.tabsize.y.other)
						ImGui.Spacing()
						
					-- velocity thresh
						ImGui.Text("[VelocitySmoothingTime]")
						ImGui.SameLine()
						HelpMarker("not tested yet")
						velo = GameOptions.GetFloat("Vehicle","VelocitySmoothingTime")
						veloch = ImGui.SliderFloat("v", velo, 0, 0.800000)
						ImGui.SameLine()
						
						if (velo) ~= (veloch) then
						GameOptions.SetFloat("Vehicle","VelocitySmoothingTime", veloch)
						end
						ImGui.SameLine()
						if (ImGui.Button("R", buttonWs, buttonHs)) then
						GameOptions.Set("Vehicle","VelocitySmoothingTime","0.300000") --pwned by setfloat
						end
						if (ImGui.IsItemHovered()) then
        				ImGui.SetTooltip("RESET to 0.300000")
						end
	  				
	  				
	  				
	  					-- tele
						ImGui.Text("[MaxForceMoveToTeleport]")
						ImGui.SameLine()
						HelpMarker("not tested yet")
						tele = GameOptions.GetFloat("Vehicle","MaxForceMoveToTeleportThreshold")
						telech = ImGui.SliderInt("f", math.floor(tele), 0, 99,"%d")
						ImGui.SameLine()
						
						if (tele) ~= (telech) then
						GameOptions.SetFloat("Vehicle","MaxForceMoveToTeleportThreshold", telech)
						end
						ImGui.SameLine()
						if (ImGui.Button("50.0", buttonWs, buttonHs)) then
						GameOptions.Set("Vehicle","MaxForceMoveToTeleportThreshold","50.0")
						end
						if (ImGui.IsItemHovered()) then
        				ImGui.SetTooltip("RESET to 50")
						end
						
						-- weight
				
						ImGui.Text("[WeightTransferMode]")
						ImGui.SameLine()
						HelpMarker("not tested yet")
						wetm = GameOptions.GetInt("Vehicle","WeightTransferMode")
						wetmch = ImGui.SliderInt("m", wetm, -1, 1,"%d")
						ImGui.SameLine()
						
						if (wetm) ~= (wetmch) then
						GameOptions.SetInt("Vehicle","WeightTransferMode", wetmch)
						end
						ImGui.SameLine()
						if (ImGui.Button("+1", buttonWs, buttonHs)) then
						GameOptions.Set("Vehicle","WeightTransferMode","1")
						end
						if (ImGui.IsItemHovered()) then
				        ImGui.SetTooltip("RESET to +1")
						end
							

					ImGui.EndTabItem()
					end
					
					if (ImGui.BeginTabItem("ABOUT")) then
						ImGui.SetWindowSize(elements.tabsize.x, elements.tabsize.y.about)
						ImGui.Spacing()		
						
					ImGui.Text("UI for car control settings was ")
					ImGui.Text("based on SIMPLE MENU mod on nexusmods.")
					ImGui.Spacing()	
					ImGui.Text("Big thanks from me and happy users :)")



						
					
					ImGui.EndTabItem()
					end
				ImGui.EndTabBar()
				end
			end
			ImGui.End()
		end
	end)

	return HandlingUtil
end

return HandlingUtil:new()